// C Source File
// Created 9/13/00; 7:30:10 PM

#define USE_GRAY_PATCH

#define SAVE_SCREEN

#include <nostub.h>  // Make NoStub Program
#include <all.h>     // Include All Header Files
#define saveVarName "bseblsve"		// defines the save file
#define saveVarSym $(bseblsve)

//************************************************
//This section stores all the constant variabls ||
//************************************************

int _ti89;           // Produce .89Z File
unsigned char* plane1=0;
unsigned char* plane2=0;
int home=0,speed=2,ustrike=0,innings=9,outs=0,uscore=0,cscore=0,cinning=1;
int youup=0,playerOnFirst=0,playerOnSecond=0,playerOnThird=0,outField=0;
int field=0,dBase=1,mode=0,teamnum=-1,opponent=0,hrd=0,plnum=0,cpnum=0,opnum=0;
int conum=0;
static unsigned int rand_seed = 0; 

//********************************
//This section sets up the teams||
//********************************

typedef struct {
	char name[15];
} players;

typedef struct {
  int wins;
  int losses;
	char team[20];
} teams;

teams select[12] = {
	{0,0,"Rappers"},
	{0,0,"Calc People"},
	{0,0,"Presidents"},
	{0,0,"Wrestlers"},
	{0,0,"Warriors"},
	{0,0,"Pop Stars"},
	{0,0,"Monsters"},
	{0,0,"Cartoons"},
	{0,0,"Super Heroes"},
	{0,0,"Video Games"},
	{0,0,"Comedians"},
	{0,0,"Star Wars"}
};

players all[117] = {
	{"Mystikal"},
	{"B. Rhymes"},
	{"P. Daddy"},
	{"Jay-Z"},
	{"E. Simmons"},
	{"M. Mathers"},
	{"Dr. Dre"},
	{"Juvenile"},
	{"Ja Rule"},
	
	{"T. Nussbaumer"},
	{"M. Johnson"},
	{"E. Sun"},
	{"P. Davidson"},
	{"N. Disabato"},
	{"S. Kelly"},
	{"R. Wagner"},
	{"E. Fry"},
	{"Joe W."},
	
	{"G. Washington"},
	{"T. Jefferson"},
	{"A. Jackson"},
	{"A. Lincoln"},
	{"T. Roosevelt"},
	{"F. Roosevelt"},
	{"H. Truman"},
	{"J. Kennedy"},
	{"B. Clinton"},
	
	{"The Rock"},
	{"Stone Cold"},
	{"Undertaker"},
	{"B. Gunn"},
	{"Road Dogg"},
	{"H. Helmsley"},
	{"M. Hardy"},
	{"B. Dudley"},
	{"M. Foley"},
	
	{"Caesar"},
	{"Napolean"},
	{"William"},
	{"Atilla"},
	{"Erik"},
	{"Beowulf"},
	{"Odysseus"},
	{"King Arthur"},
	{"Lancelot"},
	
	{"B. Spears"},
	{"C. Aguilera"},
	{"J. Timberlake"},
	{"R. Martin"},
	{"Vitamin C"},
	{"N. Carter"},
	{"E. Iglesias"},
	{"Sonique"},
	{"C. Kirkpatrick"},
	
	{"Frakenstein"},
	{"Dracula"},
	{"Werewulf"},
	{"Mummy"},
	{"Godzilla"},
	{"The Blob"},
	{"Alien"},
	{"The Predator"},
	{"Mothra"},
	
	{"Garfield"},
	{"Odie"},
	{"Dilbert"},
	{"Calvin"},
	{"Hobbes"},
	{"B. Simpson"},
	{"H. Simpson"},
	{"Archie"},
	{"E. Cartman"},
	
	{"Superman"},
	{"Batman"},
	{"Robin"},
	{"Wonderwoman"},
	{"C. America"},
	{"Spiderman"},
	{"Wolverine"},
	{"Cyclops"},
	{"Green Lantern"},
	
	{"Mario"},
	{"Luigi"},
	{"P. Peach"},
	{"Sonic"},
	{"Tails"},
	{"T. Hawk"},
	{"C. Bandicoot"},
	{"Spyro"},
	{"L. Croft"},
	
	{"C. Rock"},
	{"S. Wayans"},
	{"M. Wayans"},
	{"C. Farley"},
	{"A. Sandler"},
	{"B. Bellamy"},
	{"N. MacDonald"},
	{"D. Carey"},
	{"D. Spade"},
	
	{"L. Skywalker"},
	{"L. Organa"},
	{"H. Solo"},
	{"D. Vader"},
	{"Chewbacca"},
	{"Palpatine"},
	{"Jabba"},
	{"L. Calrissian"},
	{"B. Fett"}
};

//****************************************
//This sections defines all the graphics||
//****************************************

unsigned int battop1[] = { 0x0000,
 0x0000,0x0000,0x0180,0x0240,
 0x0240,0x0120,0x0120,0x0090,
 0x0090,0x0048,0x0048,0x0028,
 0x0024,0x0014,0x00F4};

unsigned int battop2[] = { 0x0000,
 0x0000,0x0000,0x0180,0x03C0,
 0x03C0,0x01E0,0x01E0,0x00F0,
 0x00F0,0x0078,0x0078,0x0038,
 0x003C,0x001C,0x00FC};

unsigned int batl2p1[] = { 0x007A,
 0x00CD,0x00BD,0x00EF,0x00EF,
 0x07FF,0x08FF,0x13FE,0x13FC,
 0x23F2,0x21E9,0x2019,0x2007,
 0x1007,0x100F,0x100F};

unsigned int batl2p2[] = { 0x007E,
 0x00F7,0x00C7,0x0097,0x0093,
 0x073F,0x08E3,0x1186,0x119C,
 0x20F2,0x2001,0x2001,0x2000,
 0x1003,0x1006,0x1007};
 
unsigned int batr2p1[] = { 0x0000,
 0x0000,0x8000,0xC000,0xC000,
 0xE000,0xE000,0xF000,0xF000,
 0xE000,0xE000,0xE000,0xE000,
 0xE000,0xE000,0xC000};

unsigned int batr2p2[] = { 0x0000,
 0x0000,0x8000,0xC000,0xC000,
 0xE000,0xA000,0xB000,0xB000,
 0xA000,0xA000,0xA000,0xA000,
 0xA000,0x6000,0xC000};
 
unsigned int batl3p1[] = { 0x1010,
 0x1020,0x1020,0x3040,0x3C40,
 0x57C0,0x5040,0x9040,0x9040,
 0x9040,0x9840,0x8840,0x4840,
 0x48C0,0x2CC0,0x24C0};

unsigned int batl3p2[] = { 0x1010,
 0x1020,0x1020,0x3040,0x2040,
 0x4040,0x4040,0x8040,0x8040,
 0x8040,0x8040,0x8040,0x4040,
 0x40C0,0x20C0,0x20C0};
 
unsigned int batl4p1[] = { 0x24C0,
 0x16C0,0x12C0,0x1240,0x1240,
 0x0A40,0x0A40,0x0A40,0x0A40,
 0x0A40,0x0A40,0x0A40,0x0A40,
 0x0A80,0x0A80,0x0A80};

unsigned int batl4p2[] = { 0x20C0,
 0x10C0,0x10C0,0x1040,0x1040,
 0x0840,0x0840,0x0840,0x0840,
 0x0840,0x0840,0x0840,0x0840,
 0x0880,0x0880,0x0880};
 
unsigned int batl5p1[] = { 0x0A80,
 0x0B80,0x0F00,0x0F00,0x0F80,
 0x0FE0,0x07F0,0x0000,0x0000,
 0x0000,0x0000,0x0000,0x0000,
 0x0000,0x0000,0x0000};

unsigned int batl5p2[] = { 0x0880,
 0x0980,0x0F00,0x0F00,0x0F80,
 0x0FE0,0x07F0,0x0000,0x0000,
 0x0000,0x0000,0x0000,0x0000,
 0x0000,0x0000,0x0000};
 
unsigned int sw1p1[] = { 0x0078,
 0x00CC,0x00BC,0x00EC,0x00EE,
 0x07EE,0x08FE,0x103C,0x11C2,
 0x23F2,0x23FF,0x21FF,0x20FF,
 0x103F,0x100F,0x100E};

unsigned int sw1p2[] = { 0x0078,
 0x00F4,0x00C4,0x0094,0x0092,
 0x0792,0x08E2,0x103C,0x11C2,
 0x2372,0x230F,0x21C0,0x20E0,
 0x103F,0x1009,0x100E};
 
unsigned int sw1r1[] = { 0x0000,
 0x0000,0x0000,0x0000,0x0000,
 0x0000,0x0000,0x0000,0x0000,
 0x01FE,0xFE01,0xC001,0xFE01,
 0x81FE,0x0000,0x0000};

unsigned int sw1r2[] = { 0x0000,
 0x0000,0x0000,0x0000,0x0000,
 0x0000,0x0000,0x0000,0x0000,
 0x01FE,0xFFFF,0xFFFF,0xFFFF,
 0x81FE,0x0000,0x0000};
 
unsigned int sw2lp1[] = { 0x0120,
 0x0120,0x0120,0x0120,0x0090,
 0x0090,0x0090,0x0048,0x0048,
 0x003D,0x003E,0x0018,0x0008,
 0x0008,0x0004,0x0003};

unsigned int sw2lp2[] = { 0x01E0,
 0x01E0,0x01E0,0x01E0,0x00F0,
 0x00F0,0x00F0,0x0078,0x0078,
 0x003D,0x003E,0x0018,0x0008,
 0x0008,0x0004,0x0003};
 
unsigned int sw2rp1[] = { 0x1FC0,
 0x18C0,0x1FC0,0x1040,0x1FC0,
 0x6020,0x8010,0x0F90,0x0018,
 0x1008,0x2008,0xC008,0x4008,
 0x2010,0x2010,0x0000};

unsigned int sw2rp2[] = { 0x1040,
 0x1740,0x1FC0,0x1040,0x1FC0,
 0x6020,0x8010,0x0010,0x0018,
 0x1008,0x2008,0xC008,0x4008,
 0x2010,0x2010,0x0000};
 
unsigned int sw2ulp1[] = { 0x0000,
 0x0000,0x0000,0x0000,0x0000,
 0x0000,0x0000,0x0000,0x0000,
 0x0000,0x0180,0x0240,0x0240,
 0x0240,0x0240,0x0240};

unsigned int sw2ulp2[] = { 0x0000,
 0x0000,0x0000,0x0000,0x0000,
 0x0000,0x0000,0x0000,0x0000,
 0x0000,0x0180,0x03C0,0x03C0,
 0x03C0,0x03C0,0x03C0};

unsigned int baturp1[] = { 0x0000,
 0x0000,0x0000,0x0000,0x0000,
 0x0000,0x0000,0x0000,0x0000,
 0x0000,0x0000,0x0000,0x0000,
 0x0000,0x03E0,0x0770};

unsigned int baturp2[] = { 0x0000,
 0x0000,0x0000,0x0000,0x0000,
 0x0000,0x0000,0x0000,0x0000,
 0x0000,0x0000,0x0000,0x0000,
 0x0000,0x03E0,0x0490};
 
unsigned int pitbotp1[] = { 0x1880,
 0x1C80,0x0C80,0x0A40,0x0A40,
 0x0B40,0x0B40,0x0940,0x0940,
 0x0540,0x0540,0x0540,0x0EE0,
 0x0FF0,0x0810,0x0FF0};

unsigned int pitbotp2[] = { 0x1880,
 0x1C80,0x0C80,0x0A40,0x0A40,
 0x0B40,0x0B40,0x0940,0x0940,
 0x0540,0x0540,0x07C0,0x0EE0,
 0x0000,0x07E0,0x0000};

unsigned int pittopp1[] = { 0x0000,
 0x0000,0x0000,0x0000,0x0000,
 0x0000,0x0000,0x0200,0x0600,
 0x0F80,0x1660,0x2090,0x28F0,
 0x28B0,0x38F0,0x17E0};

unsigned int pittopp2[] = { 0x0000,
 0x0000,0x0000,0x0000,0x0000,
 0x0000,0x0600,0x0E00,0x0600,
 0x0F80,0x1660,0x20B0,0x28F0,
 0x38B0,0x38F0,0x10E0};
 
unsigned int mflu2[] = { 0xFFFF,
 0x8003,0x8002,0x8003,0x8004,
 0x8008,0x8010,0x8020,0x8040,
 0x8080,0x8100,0x8200,0x8400,
 0x8800,0xF000,0xD000};

unsigned int mflu1[] = { 0x0000,
 0x0003,0x0002,0x0003,0x0004,
 0x0008,0x0010,0x0020,0x0040,
 0x0080,0x0100,0x0200,0x0400,
 0x0800,0x7000,0x5000};

unsigned int mfru2[] = { 0xFFFF,
 0xC001,0x4001,0xC001,0x2001,
 0x1001,0x0801,0x0401,0x0201,
 0x0101,0x0081,0x0041,0x0021,
 0x0011,0x000F,0x000B};

unsigned int mfru1[] = { 0x0000,
 0xC000,0x4000,0xC000,0x2000,
 0x1000,0x0800,0x0400,0x0200,
 0x0100,0x0080,0x0040,0x0020,
 0x0010,0x000E,0x000A};
 
unsigned int mfld2[] = { 0xD000,
 0xF000,0x8800,0x8400,0x8200,
 0x8100,0x8080,0x8040,0x8020,
 0x8010,0x8008,0x8004,0x8003,
 0x8002,0x8001,0xFFFF};

unsigned int mfld1[] = { 0x5000,
 0x7000,0x0800,0x0400,0x0200,
 0x0100,0x0080,0x0040,0x0020,
 0x0010,0x0008,0x0004,0x0003,
 0x0002,0x0001,0x0000};
 
unsigned int mfrd2[] = { 0x000B,
 0x000F,0x0011,0x0021,0x0041,
 0x0081,0x0101,0x0201,0x0401,
 0x0801,0x1001,0x2001,0xC001,
 0x4001,0x8001,0xFFFF};

unsigned int mfrd1[] = { 0x000A,
 0x000E,0x0010,0x0020,0x0040,
 0x0080,0x0100,0x0200,0x0400,
 0x0800,0x1000,0x2000,0xC000,
 0x4000,0x8000,0x0000};
 
unsigned int genpl2[] = { 0x0000,
 0x0380,0x07C0,0x0C60,0x1390,
 0x2008,0x2D68,0x2C68,0x1550,
 0x0380,0x07C0,0x0FE0,0x1EF0,
 0x1C70,0x7C7C,0x7C7C};

unsigned int genpl1[] = { 0x0000,
 0x0380,0x0440,0x0FE0,0x1FF0,
 0x3FF8,0x3AB8,0x3FF8,0x16D0,
 0x0380,0x0440,0x0920,0x1290,
 0x1450,0x7C7C,0x7C7C};

unsigned int mask[] = { 0x0000,
 0x0000,0x0000,0x0000,0x0000,
 0x0000,0x0000,0x0000,0x0000,
 0x0000,0x0000,0x0000,0x0000,
 0x0000,0x0000,0x0000};

//************************************************************
//this functions generates a random number between 0 and x-1||
//************************************************************

int rdnm(int x)
{
  return(rand_seed=(75*rand_seed+1))%x;
}

//*********************************************************
//This function clears both planes for grayscale graphics||
//*********************************************************

void clear()
{
	SetPlane(0);
	ClrScr();
	SetPlane(1);
	ClrScr();
}

//***************************
//Draws the generic fielder||
//***************************

void DrawFielder(int x, int y)
{
	Sprite16(x,y,16,genpl1,plane1,SPRT_OR);
	Sprite16(x,y,16,genpl2,plane2,SPRT_OR);
}

//**********************
//Draws the base lines||
//**********************

void DrawLines()
{
	DrawLine(75,92,80,92,A_NORMAL);
	DrawLine(75,92,75,94,A_NORMAL);
	DrawLine(80,92,80,94,A_NORMAL);
	DrawLine(75,94,77,96,A_NORMAL);
	DrawLine(80,94,78,96,A_NORMAL);
	DrawLine(41,58,74,91,A_NORMAL);
	DrawLine(81,91,114,58,A_NORMAL);
	DrawLine(40,57,36,57,A_NORMAL);
	DrawLine(36,57,36,53,A_NORMAL);
	DrawLine(36,53,40,53,A_NORMAL);
	DrawLine(40,53,40,57,A_NORMAL);
	DrawLine(41,52,74,19,A_NORMAL);
	DrawLine(75,18,80,18,A_NORMAL);
	DrawLine(80,18,80,13,A_NORMAL);
	DrawLine(80,13,75,13,A_NORMAL);
	DrawLine(75,13,75,18,A_NORMAL);
	DrawLine(81,19,114,52,A_NORMAL);
	DrawLine(115,53,115,57,A_NORMAL);
	DrawLine(115,57,119,57,A_NORMAL);
	DrawLine(119,57,119,53,A_NORMAL);
	DrawLine(119,53,115,53,A_NORMAL);
}

//*******************************************
//Sets up the pointer to which player is up||
//*******************************************

void teamExtras()
{
	plnum=teamnum*9;
	opnum=opponent*9;
	conum=opnum;
	cpnum=plnum;
}

//****************************************************
//Lets you pick a team for both either opponent and you||
//****************************************************

int PickTeam(int x)
{
	int y=0,key=0,tmp=11,change=1,i;
	clear();
	FontSetSys(F_4x6);
	for(y=0;y<=8;y++)
		DrawLine(0,y,160,y,3);
	if(teamnum==-1)
		DrawStr(1,2,"Choose Your Team:",A_XOR);
	else
		DrawStr(70,2,"Choose Opponent:",A_XOR);
	y=13;
	while(key!=264)
		{
		if(change)
			{
			tmp=14;
			for(i=0;i<12;i++)
				{
				DrawStr(x,tmp,select[i].team,A_NORMAL);
				tmp=tmp+7;
				}
			for(tmp=y;tmp<=y+6;tmp++)
				DrawLine(x,tmp,x+50,tmp,A_XOR);
			}
		change=0;
		key=ngetchx();
		if(key==340 && y!=90)
			{
			change=1;
			for(tmp=y;tmp<=y+6;tmp++)
				DrawLine(x,tmp,x+50,tmp,A_XOR);
			y=y+7;
			}
		if(key==337 && y!=13)
			{
			change=1;
			for(tmp=y;tmp<=y+6;tmp++)
				DrawLine(x,tmp,x+50,tmp,A_XOR);
			y=y-7;
			}
		if(key==268)
			{
				if(teamnum==-1)
					teamnum=(y+1)/7-2;
				else
					opponent=(y+1)/7-2;
				teamExtras();
				return 1;
			}
		}
	return 0;
}

//******************************
//Writes out the versus screen||
//******************************

void DispTeams()
{
	int i,tmp=12,end;
	ClrScr();
	FontSetSys(F_4x6);
	end=teamnum*9;
	DrawStr(1,1,select[teamnum].team,1);
	for(i=end;i<end+9;i++)
		{
		DrawStr(1,tmp,all[i].name,1);
		tmp=tmp+7;
		}
	DrawStr(105,1,select[opponent].team,1);
	end=opponent*9;
	tmp=12;
	for(i=end;i<end+9;i++)
		{
		DrawStr(105,tmp,all[i].name,1);
		tmp=tmp+7;
		}
	FontSetSys(F_8x10);
	DrawStr(65,35,"VS",1);
	ngetchx();
}

//***************************************************************
//The next few functions all deal with the save and load season||
//***************************************************************

void addWin(int i)
{
	select[i].wins++; //adds a win onto the current teams stats
}

void addLoss(int i)
{
	select[i].losses++;  //adds a loss onto the current teams stats
}

//**********************************************
//draws the header for the season stats screen||
//**********************************************

void header()
{
	int i;
	for(i=0;i<7;i++)
		DrawLine(0,i,160,i,3);
	DrawStr(1,1,"Season Stats -- ",A_XOR);
	DrawStr(56,1,select[teamnum].team,A_XOR);
}

//**********************
//writes the save file||
//**********************

void SaveSeason()
{
	int i=0,add=1;
	FILE* fp;
	FontSetSys(F_4x6);
	if (!(fp=fopen(saveVarName, "wb"))) return; //creates file if necessary
	fputc(0,fp);  //leading zero is required
	fputc(teamnum,fp);
	if(uscore>cscore)
		{
		addWin(teamnum);
		addLoss(opponent);
		}
	else
		{
		addLoss(teamnum);
		addWin(opponent);
		}
	while(i<12)
		{
		if(i!=teamnum && i!=opponent)
			{
			if(i+1!=opponent && i+1!=teamnum)
				add=1;
			else
				add=2;
			if(rdnm(2)==0)
				{
				addWin(i);
				addLoss(i+add);
				}
			else
				{
				addLoss(i);
				addWin(i+add);
				}
			i++;
			}
		i=i+add;
		}
	for(i=0;i<12;i++)
		{
		fputc(i & 0xff,fp);
		fputc(select[i].wins & 0xff,fp);
		fputc(select[i].losses & 0xff,fp);
		}
	fputc(opponent+1,fp); //the next team you will face
	fputc(0,fp); //the trailing zero is required
	fputc(STR_TAG,fp); //makes it into a string on the calc
	fclose(fp);	
}

//********************************************************
//reads the save file and puts the values into variables||
//********************************************************

int ReadSeason()
{
	int i,tmp;
	FILE* fp;
	FontSetSys(F_4x6);
	if (!(fp=fopen(saveVarName, "rb"))) return 0; //checks for file existence
	fgetc(fp); //skips the leading zero
	teamnum=fgetc(fp);
	clear();
	header(); //draws the header
	//for loop writes the team names out and their wins and losses
	for(i=0;i<12;i++)
		{
		tmp=fgetc(fp);
		DrawStr(1,i*7+8,select[tmp].team,1);
		tmp=fgetc(fp);
		printf_xy(100,i*7+8,"%d",tmp);
		tmp=fgetc(fp);
		printf_xy(120,i*7+8,"%d",tmp);
		}
	opponent=fgetc(fp);
	fclose(fp);
	ngetchx();
	return 1; //says file existed
}

//*********************
//draws the infielders||
//**********************

void DrawFielders()
{
	DrawFielder(26,37);
	DrawFielder(46,16);
	DrawFielder(85,6);
	DrawFielder(116,37);
	DrawFielder(71,42);
}

//*************************************
//draws the small field in the corner||
//*************************************

void DrawMiniField()
{
  int i;
	Sprite16(126,66,16,mask,plane2,SPRT_AND);
	Sprite16(126,66,16,mask,plane1,SPRT_AND);
	Sprite16(142,66,16,mask,plane2,SPRT_AND);
	Sprite16(142,66,16,mask,plane1,SPRT_AND);
	Sprite16(126,66,16,mflu1,plane1,SPRT_OR);
	Sprite16(126,66,16,mflu2,plane2,SPRT_OR);
	Sprite16(142,66,16,mfru1,plane1,SPRT_OR);
	Sprite16(142,66,16,mfru2,plane2,SPRT_OR);
	Sprite16(126,82,16,mask,plane2,SPRT_AND);
	Sprite16(126,82,16,mask,plane1,SPRT_AND);
	Sprite16(142,82,16,mask,plane2,SPRT_AND);
	Sprite16(142,82,16,mask,plane1,SPRT_AND);
	Sprite16(126,82,16,mfld1,plane1,SPRT_OR);
	Sprite16(126,82,16,mfld2,plane2,SPRT_OR);
	Sprite16(142,82,16,mfrd1,plane1,SPRT_OR);
	Sprite16(142,82,16,mfrd2,plane2,SPRT_OR);
	if(playerOnFirst)
		{
		for(i=78;i<=80;i++)
			{
			DrawLine(152,i,154,i,0);
			DrawLine(152,i,154,i,A_OR);
			}
		}	
	if(playerOnSecond)
		{
		for(i=69;i<=71;i++)
			{
			DrawLine(138,i,140,i,0);
			DrawLine(138,i,140,i,A_OR);
			}
		}
	if(playerOnThird)
		{
		for(i=83;i<=85;i++)
			{
			DrawLine(129,i,131,i,0);
			DrawLine(129,i,131,i,A_OR);
			}
		}
}

//**************************************************
//draws an inverse of the fielder to make a runner||
//**************************************************

void DrawPL1(int x,int y)
{
	Sprite16(x,y,16,genpl2,plane1,SPRT_OR);
	Sprite16(x,y,16,genpl1,plane2,SPRT_OR);
}

//***********************
//draws all the runners||
//***********************

void DrawRunners()
{
	if(playerOnFirst)
		DrawPL1(102,38);
	if(playerOnSecond)
		DrawPL1(62,4);
	if(playerOnThird)
		DrawPL1(39,43);
}

//*****************
//draws the field||
//*****************

void DrawField()
{
	DrawLines();
	DrawFielders();
	DrawMiniField();
	DrawRunners();
}

//********************************
//draws the stat box on the left||
//********************************

void statDraw()
{
	DrawLine(0,77,0,99,3);
	DrawLine(0,77,36,77,3);
	DrawLine(36,77,36,99,3);
	DrawLine(0,99,36,99,3);
	FontSetSys(F_4x6);
	DrawStr(2,79,"Strikes:",A_NORMAL);
	DrawStr(2,86,"    Outs:",A_NORMAL);
  DrawStr(2,93," Inning:",A_NORMAL);
  DrawStr(2,69,"You:",A_NORMAL);
  DrawStr(2,62,"Comp:",A_NORMAL);
	printf_xy(31,79,"%d",ustrike);
	printf_xy(31,86,"%d",outs);
	printf_xy(31,93,"%d",cinning);
	printf_xy(31,69,"%d",uscore);
	printf_xy(31,62,"%d",cscore);
}

//*****************************
//draws the pitcher and mound||
//*****************************

void DrawPitcher()
{
  int x=71;
	Sprite16(x,10,16,pitbotp2,plane1,SPRT_OR);
	Sprite16(x,10,16,pitbotp1,plane2,SPRT_OR);
	Sprite16(x,-6,16,pittopp2,plane1,SPRT_OR);
	Sprite16(x,-6,16,pittopp1,plane2,SPRT_OR);
}

//**************
//draws batter||
//**************

void DrawBatter()
{
  int x=49; //makes it easier to change location
	Sprite16(x,26,16,battop2,plane1,SPRT_OR);
	Sprite16(x,26,16,battop1,plane2,SPRT_OR);
	Sprite16(x-1,41,16,batl2p2,plane1,SPRT_OR);
	Sprite16(x-1,41,16,batl2p1,plane2,SPRT_OR);
	Sprite16(x+15,41,16,batr2p2,plane1,SPRT_OR);
	Sprite16(x+15,41,16,batr2p1,plane2,SPRT_OR);
	Sprite16(x,57,16,batl3p2,plane1,SPRT_OR);
	Sprite16(x,57,16,batl3p1,plane2,SPRT_OR);
	Sprite16(x,73,16,batl4p2,plane1,SPRT_OR);
	Sprite16(x,73,16,batl4p1,plane2,SPRT_OR);
	Sprite16(x,89,16,batl5p2,plane2,SPRT_OR);
	Sprite16(x,89,16,batl5p1,plane1,SPRT_OR);
}

//******************************************
//draws the base lines in the batting view||
//******************************************

void drawBField()
{
  DrawLine(73,85,83,85,4);
  DrawLine(73,85,73,90,4);
  DrawLine(83,85,83,90,4);
  DrawLine(74,91,74,92,4);
  DrawLine(82,91,82,92,4);
  DrawLine(74,92,78,96,4);
  DrawLine(82,92,78,96,4);
  DrawLine(84,84,159,9,4);
  DrawLine(72,84,59,71,4);
  DrawLine(49,61,0,12,4);
}

//***************************
//draws the swing animation||
//***************************

void swinged()
{
	int i;
	int x=49;
	Sprite16(x,26,16,mask,plane1,SPRT_AND);
	Sprite16(x,26,16,mask,plane2,SPRT_AND);
	Sprite16(x-1,41,16,mask,plane1,SPRT_AND);
	Sprite16(x-1,41,16,mask,plane2,SPRT_AND);
	Sprite16(x+15,41,16,mask,plane1,SPRT_AND);
	Sprite16(x+15,41,16,mask,plane2,SPRT_AND);
	Sprite16(x+15,41,16,sw1r2,plane1,SPRT_OR);
	Sprite16(x+15,41,16,sw1r1,plane2,SPRT_OR);
	Sprite16(x-1,41,16,sw1p2,plane1,SPRT_OR);
	Sprite16(x-1,41,16,sw1p1,plane2,SPRT_OR);
	Sprite16(x,57,16,batl3p2,plane1,SPRT_OR);
	Sprite16(x,57,16,batl3p1,plane2,SPRT_OR);
	Sprite16(x,73,16,batl4p2,plane1,SPRT_OR);
	Sprite16(x,73,16,batl4p1,plane2,SPRT_OR);
	Sprite16(x,89,16,batl5p2,plane2,SPRT_OR);
	Sprite16(x,89,16,batl5p1,plane1,SPRT_OR);
	for(i=0;i<=11000;i++)
		{}
	Sprite16(x,26,16,mask,plane1,SPRT_AND);
	Sprite16(x,26,16,mask,plane2,SPRT_AND);
	Sprite16(x-1,41,16,mask,plane1,SPRT_AND);
	Sprite16(x-1,41,16,mask,plane2,SPRT_AND);
	Sprite16(x+15,41,16,mask,plane1,SPRT_AND);
	Sprite16(x+15,41,16,mask,plane2,SPRT_AND);
	Sprite16(x-1,26,16,baturp2,plane1,SPRT_OR);
	Sprite16(x-1,26,16,baturp1,plane2,SPRT_OR);
	Sprite16(x-15,23,16,sw2ulp2,plane1,SPRT_OR);
	Sprite16(x-15,23,16,sw2ulp1,plane2,SPRT_OR);
	Sprite16(x-15,39,16,sw2lp2,plane1,SPRT_OR);
	Sprite16(x-15,39,16,sw2lp1,plane2,SPRT_OR);
	Sprite16(x+1,42,16,sw2rp2,plane1,SPRT_OR);
	Sprite16(x+1,42,16,sw2rp1,plane2,SPRT_OR);
	Sprite16(x,57,16,batl3p2,plane1,SPRT_OR);
	Sprite16(x,57,16,batl3p1,plane2,SPRT_OR);
	Sprite16(x,73,16,batl4p2,plane1,SPRT_OR);
	Sprite16(x,73,16,batl4p1,plane2,SPRT_OR);
	Sprite16(x,89,16,batl5p2,plane2,SPRT_OR);
	Sprite16(x,89,16,batl5p1,plane1,SPRT_OR);
}

//*******************************************************
//the following three draw the outfields and outfielders||
//********************************************************

void DrawLeft(int x, int y)
{
	DrawLine(0,70,43,37,1);
	DrawLine(0,93,43,61,1);
	DrawLine(43,37,43,61,1);
	DrawLine(43,37,107,24,1);
	DrawLine(43,61,107,47,1);
	DrawLine(107,24,107,47,1);
	DrawLine(107,24,159,20,1);
	DrawLine(104,47,159,43,1);
	DrawFielder(x,y);
	DrawMiniField();
}

void DrawCenter(int x, int y)
{
	DrawLine(0,21,47,17,1);
	DrawLine(0,44,47,40,1);
	DrawLine(47,17,47,40,1);
	DrawLine(47,17,112,17,1);
	DrawLine(47,40,112,40,1);
	DrawLine(112,17,112,40,1);
	DrawLine(112,17,159,21,1);
	DrawLine(112,40,159,44,1);
	DrawFielder(x,y);
	DrawMiniField();
}

void DrawRight(int x, int y)
{
	DrawLine(0,20,51,24,1);
	DrawLine(0,43,51,47,1);
	DrawLine(51,24,51,47,1);
	DrawLine(51,24,115,37,1);
	DrawLine(51,47,115,61,1);
	DrawLine(115,37,115,61,1);
	DrawLine(115,37,159,70,1);
	DrawLine(115,61,159,93,1);
	DrawFielder(x,y);
	DrawMiniField();
}

//***************
//draws the hit||
//***************

void DrawHit(int playerX,int playerY,int outField,int yadd,int xadd,int newx,int stopat,int stopatOut)
{
  void *kbq = kbd_queue( ); //low level, constant keyboard reading
	int tmp,hitx,hity,end,key=0,i;
	hitx=77;
	hity=86;
	if(outField==-2)
		{
		stopat=stopatOut;
		hitx=newx;
		hity=96;
		}
	while(hity>stopat)
		{
		end=hity-yadd;
		OSdequeue(&key, kbq); //check keypad
		for(tmp=hity;tmp>end;tmp--)
			{
			DrawLine(hitx-3,tmp+1,hitx+5,tmp+1,0);
			for(i=tmp;i>=tmp-2;i--)
				DrawLine(hitx,i,hitx+2,i,3); //draw ball
			OSdequeue(&key, kbq); //check keypad again (this helps somehow...)
			if(outField==-2)
				{
				if(field==1)
					DrawLeft(playerX,playerY);       //if ball is in outfield
				if(field==2)                       //then draws the different
					DrawCenter(playerX,playerY);     //fields based on which one
				if(field==3)                       //the ball is in
					DrawRight(playerX,playerY);
				}
			else
				{
				DrawRunners();                     //if ball is in infield
				DrawLines();                       //draw the infield
				DrawFielders();
				}
			if(key!=0)
				{
				if(key==337) dBase=2;              //if you press a key
				if(key==344) dBase=1;              //set the desired base
				if(key==338) dBase=3;
				key=0;                             //set key back to zero
				}
			if(stopatOut==0)
				dBase=4;                           //sets homerun
			}
		hity=tmp;
		hitx=hitx+xadd;
		}
}

//********************************************************************
//out for Homerun derby is different from regular out, so this is it||
//********************************************************************

void addHRD()
{
	DrawStr(1,1,"Out!",A_REPLACE);
	outs++;
	ngetchx();
}

//************
//normal out||
//************

void addOut()
{
	if(mode!=1)
	{
		if(outField==-1)
			DrawLines();
		DrawStr(72,1,"OUT!",1);
		outs++;
		ngetchx();
	}
}

//*****************************************************
//allows for throw outs if you go for too high a base||
//*****************************************************

void throwOut()
{
	DrawStr(10,1,"Thrown Out!",1);
	outs++;
}

//************************
//advances runners, etc.||
//************************

void addHit(int whereX)
{
  int score=0;
if(mode!=1)
	{
	if(dBase==1)
		{
		DrawStr(10,1,"Single!",1);
		if(playerOnThird)
			{
			score++;
			playerOnThird=0;
			}
		if(playerOnSecond)
			{
			playerOnSecond=0;
			playerOnThird=1;
			}
		if(playerOnFirst)
			playerOnSecond=1;
		playerOnFirst=1;
		}
	if(dBase==2)
		{
		DrawStr(10,1,"Double!",1);
		if(playerOnThird)
			{
			playerOnThird=0;
			score++;
			}
		if(playerOnSecond)
			{
			playerOnSecond=0;
			score++;
			}
		if(playerOnFirst)
			{
			playerOnFirst=0;
			playerOnThird=1;
			}
			playerOnSecond=1;
		}
	if(dBase==3)
		{
		if(field==3 && whereX>65)
			{
			if(playerOnFirst)
				score++;
			if(playerOnSecond)
				score++;
			if(playerOnThird)
				score++;
			playerOnFirst=0;
			playerOnSecond=0;
			playerOnThird=1;
			DrawStr(10,1,"Triple!",1);
			}
		else
			{
			if(playerOnThird)
				{
				score++;
				playerOnThird=0;
				}
			if(playerOnSecond)
				playerOnSecond=0;
			if(playerOnFirst)
				playerOnFirst=0;
			throwOut();
			}
		}
		ngetchx();
	}
		if(dBase==4)
			{
			hrd=1;
			DrawStr(10,1,"Home Run!",1);
			score++;
			if(playerOnFirst)
				score++;
			if(playerOnSecond)
				score++;
			if(playerOnThird)
				score++;
			playerOnFirst=0;
			playerOnSecond=0;
			playerOnThird=0;
			ngetchx();
			}
		dBase=1;
		if(score>0 && outs!=3 && mode!=1)
			{
			if(youup)
				{
				DrawStr(110,1,"You Scored!",1);
				uscore=uscore+score;
				}
			else
				{
				DrawStr(110,1,"They Scored!",1);
				cscore=cscore+score;			
				}
			ngetchx();
			}
}

//**************************
//draws the batting screen||
//**************************

void batGUI()
{
  statDraw();
  DrawPitcher();
  drawBField();
  DrawBatter();
  DrawMiniField();
}

//***************
//adds a strike||
//***************

void strike()
{
	DrawStr(1,1,"STRIKE",1);
	ustrike++;
	ngetchx();
}

//*******************************
//figures out where hit will go||
//*******************************

void hitset(int rX,int sX,int fld, int xadd)
{
  int isOut,stopat,stopatOut,yadd=0,playerY,playerX,outField=2,newx;
  int multiplier=0,cfld=0;
	isOut=rdnm(10)+1;
	field=fld;
	if(isOut>=6)
	  isOut=0;
	else
		isOut=1;
	stopat=0;
	playerX=(rdnm(rX)*2)+sX;
	if(playerX>=70)
		{
		multiplier=1;
		yadd=9;
		cfld=1;
		}
	if(playerX>=40 && playerX<70)
		{
		multiplier=3;
		yadd=6;
		cfld=0;
		}
	if(playerX>=0 && playerX<40)
		{
		multiplier=7;
		yadd=3;
		cfld=-1;
		}
	if(field==2)
		{
		multiplier=1;
		yadd=9;
		xadd=cfld;
		}
	playerY=60+(random(multiplier)*yadd);
	if(isOut)
		{
		stopatOut=playerY;
		playerY=playerY-4;
		}
	else
		{
		stopatOut=playerY-yadd;
		if(mode!=1)
			{
			if(rdnm(8)==rdnm(8))
				stopatOut=0;
			}
		if(mode==1)
			{
			if(rdnm(2)==rdnm(2))
				stopatOut=0;
			}
		}
	if(playerX<5)
		newx=playerX-((96-playerY)/yadd);	
	else
		newx=playerX+((96-playerY)/yadd);
	while(outField>=0)
		{
		if(outField==1)
			{
			clear();
			if(field==1)
				DrawLeft(playerX,playerY);
			if(field==2)
				DrawCenter(playerX,playerY);
			if(field==3)
				DrawRight(playerX,playerY);
			outField=-2;
			}
		DrawHit(playerX,playerY,outField,yadd,xadd,newx,stopat,stopatOut);
		outField--;
		}
	if(isOut)
		addOut();
	else
		addHit(playerX);
}

//***********************************************
//figures out which field the ball will go into||
//***********************************************

void hit(int ball)
{
  clear();
  FontSetSys(F_4x6);
  DrawField();
	if(ball>=40 && ball<=46)
		hitset(26,54,1,-1);
	if(ball>=47 && ball<=53)
		hitset(54,0,2,0);
	if(ball>=54 && ball<=60)
		hitset(45,0,3,1);
}

//*****************
//swinging engine||
//*****************

int yourUp()
{
  int i,key=0,ball=8,tmp;
  void *kbq = kbd_queue( ); //low-level key access
  clear();
  batGUI();
  if(mode!=1)
  	DrawStr(5,10,all[cpnum].name,1);  //writes player name
  while(key==0)
	{
	key=ngetchx();
	if(key==264)
		return 0;
	}
	while(ball<70)
	{
		DrawLine(74,ball-1,76,ball-1,0);
		for(tmp=ball;tmp<=ball+2;tmp++)
			DrawLine(74,tmp,76,tmp,A_NORMAL);
		ball++;
		DrawPitcher();
		OSdequeue(&key, kbq);  //reads key pad
		if(key==268)
		{
			swinged();
			if(ball>=40 && ball<=60)
			{
				ustrike=-1;
				hit(ball);
				return ustrike;
			}
			else
			{
		  	strike();
		  	return ustrike;
		  }
		}
		for(i=0;i<=speed*10000;i++)
			{}
	}
	strike();
	return ustrike;
}

//*******************
//lets computer bat||
//*******************

int compUp()
{
  int i,key=0,ball=8,wasHit=0,tmp;
  dBase=rdnm(2)+1;
  clear();
  batGUI();
  if(mode!=1)
  	DrawStr(5,10,all[conum].name,1);
  if(rdnm(5)+1!=5)
  	wasHit=rdnm(3)+1;
  while(key==0)
	{
	key=ngetchx();
	if(key==264)
		return 0;
	}
	while(ball<70)
	{
		DrawLine(74,ball-1,76,ball-1,0);
		for(tmp=ball;tmp<=ball+2;tmp++)
			DrawLine(74,tmp,76,tmp,1);
		ball++;
		DrawPitcher();
		if(wasHit!=0)
			{
			if(ball>=45 && ball<=55)
				{
				swinged();
				if(wasHit==1)
					ball=46;
				if(wasHit==2)
					ball=50;
				if(wasHit==3)
					ball=54;
				hit(ball);
				ustrike=-1;
				return ustrike;
				}
			}
		if(wasHit==0 && ball>=79 && ball<=82)
		{
			swinged();
			strike();
			return ustrike;
		}
		for(i=0;i<=speed*10000;i++)
			{}
	}
	strike();
	return ustrike;
}

//*********************
//handles strike outs||
//*********************

void StrikeOut()
{
	DrawStr(1,1,"STRIKE OUT!",1);
	ngetchx();
	DrawStr(1,1,"                   ",A_REPLACE);
  outs++;
}

//**********************************************
//cleans up before games and inbetween innings||
//**********************************************

void strd()
{
	ustrike=0;
	outs=0;
	playerOnFirst=0;
	playerOnSecond=0;
	playerOnThird=0;
}

//**********************************
//initializes values before a game||
//**********************************

void setup()
{
	uscore=0;
	cscore=0;
	cinning=1;
	innings=5;
	strd();
	if(home)
		youup=0;
	else
		youup=1;
	dBase=1;
	mode=0;
  teamnum=-1;
  opponent=0;
  cpnum=1;
  conum=1;
}

//*****************************
//cleans up inbetween innings||
//*****************************

void cleanup()
{
	strd();
	if(youup)
		DrawStr(1,1,"Your Up",1);
	else
		DrawStr(1,1,"Comp Up",1);
	ngetchx();
	DrawStr(1,1,"      ",A_REPLACE);
}

//**************************
//handles the opening menu||
//**************************

int menu()
{
	int y=0,key=0,tmp=0,change=1;
	clear();
	FontSetSys(F_6x8);
	for(y=0;y<=8;y++)
		DrawLine(0,y,160,y,3);
	for(y=90;y<=99;y++)
		DrawLine(0,y,160,y,3);
	DrawStr(43,1,"Baseball 89",A_XOR);
	DrawStr(12,91,"By: Sean Kelly (c) 2000",A_XOR);
	DrawStr(20,12,"Select Your Options:",1);
	DrawLine(0,21,160,21,3);
	y=26;
	while(key!=264)
		{
		if(change)
			{
			DrawStr(5,27,"Play Ball!",1);
			DrawStr(5,37,"     Mode:",1);
			DrawStr(5,47,"  Innings:",1);
			DrawStr(5,57,"    Speed:",1);
			DrawStr(5,67,"     Home:",1);
			DrawStr(5,77,"     Exit",1);
			for(tmp=y;tmp<=y+9;tmp++)
				DrawLine(4,tmp,65,tmp,A_XOR);
			}
		change=0;
		printf_xy(80,47,"%d",innings);
		printf_xy(80,57,"%d",speed);
		if(home)
			DrawStr(80,67,"Yes",A_REPLACE);
		else
			DrawStr(80,67,"No ",A_REPLACE);
		switch(mode)
			{
			case 0:
				DrawStr(80,37,"Exhibition    ",A_REPLACE); break;
			case 1:
				DrawStr(80,37,"Homerun Derby",A_REPLACE); break;
			case 2:
				DrawStr(80,37,"Season        ",A_REPLACE); break;
			}
		key=ngetchx();
		if(key==340)
			{
			change=1;
			for(tmp=y;tmp<=y+9;tmp++)
				DrawLine(4,tmp,65,tmp,A_XOR);
			y=y+10;
			}
		if(key==337)
			{
			change=1;
			for(tmp=y;tmp<=y+9;tmp++)
				DrawLine(4,tmp,65,tmp,A_XOR);
			y=y-10;
			}
		if(key==344)
			{
			if(y==36)
				{
				mode++;
				if(mode==3) mode=0;
				}
			if(y==46)
				{
				if(innings!=9) innings=innings+2;
				}
			if(y==56)
				{
				if(speed!=3) speed++;
				}
			if(y==66)
				{
				if(home!=1) home=1;
				}
			}
		if(key==338)
			{
			if(y==36)
				{
				mode--;
				if(mode==-1) mode=2;
				}
			if(y==46)
				{
				if(innings!=1) innings=innings-2;
				}
			if(y==56)
				{
				if(speed!=1) speed--;
				}
			if(y==66)
				{
				if(home!=0) home=0;
				}
			}
		if(key==268)
			{
			if(y==26)
				return 1;
			if(y==76)
				return 0;
			}
		if(y==16) y=76;
		if(y==86) y=26;
		}
	return 0;
}

//*************************************
//checks to see if you won the season||
//*************************************

//*******************
//resets the season||
//*******************

void resetSeason()
{
	int i;
	for(i=0;i<12;i++)
		{
		select[i].wins=0;
		select[i].losses=0;
		}
}

void testWin()
{
	int i,wins,loss=0;
	wins=select[teamnum].wins;
	for(i=0;i<12;i++)
		{
		if(i!=teamnum)
			{
			if(select[i].wins>wins)
				loss=1;
			}
		}
	if(loss)
		DrawStr(5,65,"You Lost The Season!",1);
	else
		DrawStr(5,65,"You Won the Season!",1);
	resetSeason();
}

// Main Function
int _main()
{
	GrayMode(GRAY_ON);
	plane1 = GetPlane(0);
  plane2 = GetPlane(1);
  rand_seed=137*peek(0x600017);  //sets the seed for random numbers
  setup();
   	if(menu())
   	{
   		if(mode!=1)
   		{
   			if(mode==0)
   			{
					if(PickTeam(1) && PickTeam(70))
						DispTeams();
				}
				else 
				{
					if(!(ReadSeason()))
						{
						resetSeason();
						PickTeam(1);
						opponent=0;
						}
					if(teamnum==opponent) opponent++;
						DispTeams();
					teamExtras();
				}
				while(cinning<=innings)
				{
				if(youup)
  	 	 		{
   		 		while(outs<3)
   	 				{
		   		 	while(ustrike!=3 && ustrike!=-1)
  		  			{
    					if(!(yourUp()))
    						{
	    					GrayMode(GRAY_OFF);
  	  					return 0;
    						}
    					}
    				if(ustrike==3)
							StrikeOut();
						cpnum++;
  	        if(cpnum==plnum+9) cpnum=plnum;
    				ustrike=0;
	   	 			}
	   	 		youup=0;
					cleanup();
					if(home)
						cinning++;
	   	 		}
  	 		else
   		 		{
   		 		while(outs!=3)
   	 				{
		   		 	while(ustrike<3 && ustrike!=-1)
  		  			{
    					if(!(compUp()))
    						{
	    					GrayMode(GRAY_OFF);
  	  					return 0;
    						}
    					}
    				if(ustrike==3)
    					StrikeOut();
    	  		conum++;
  					if(conum==opnum+9) conum=opnum;
    				ustrike=0;
	   	 			}
	   	 		youup=1;
					cleanup();
					if(home==0)
		   	 		cinning++;
	   	 		}
	   	 	if(cinning>innings)
	   	 		{
	   	 		if(uscore==cscore)
	   	 			innings++;
	   	 		}
   	 	}
   	 		clear();
   	 		if(mode==2)
   	 			SaveSeason();
   	 		clear();
   	 		FontSetSys(F_8x10);
   	 		if(uscore>cscore)
   	 			DrawStr(53,40,"YOU WIN!",1);
   	 		if(uscore<cscore)
   	 			DrawStr(48,40,"YOU LOST!",1);
   	 		if(select[teamnum].wins + select[teamnum].losses >= 11)
   	 			testWin();
   	 		ngetchx();
   	 		clear();
   	 	}
   	 	else
   	 	{
   		 	while(outs<10)
   	 			{
		   		while(ustrike!=1 && ustrike!=-1)
  		  		{
    				if(!(yourUp()))
    					{
	    				GrayMode(GRAY_OFF);
  	  				return 0;
    					}
    				}
					if(hrd==1)
						uscore++;
					else
						addHRD();
    			ustrike=0;
    			hrd=0;
	   	 		}
	   	 		clear();
	   	 		FontSetSys(F_8x10);
	   	 		DrawStr(1,1,"You Got:",1);
	   	 		printf_xy(70,1,"%d",uscore);
	   	 		DrawStr(1,15,"Homeruns",1);
	   	 		ngetchx();
   	 	}
		}
  GrayMode(GRAY_OFF);
	return 0;
}
